  #include <iostream>
  #include <iomanip>
  #include <fstream>
  #include "LinearAlgebra.h"
  #include "Type.h"
  #include <complex.h>

// 2 spin density matrix ; removed exchange 

  using namespace std;

  void density_matrix_1( const params * P , cdouble * FID ) {

////////////////////////////////////////////////////////////////////////////////////////////////
//// Define matrices and allocate memory

  const complex<double> im(0.0, 1.0);
  double t ;
  int n = 2 , m = 2 ;
  int order = 2 ;

  cdouble *A; 		A = new cdouble[n*m];
  cdouble *B; 		B = new cdouble[n*m];
  cdouble *C; 		C = new cdouble[n*m];
  cdouble *D; 		D = new cdouble[n*m]; 
  cdouble *E; 		E = new cdouble[n*m];
  cdouble *F; 		F = new cdouble[n*m];
  cdouble *IxS;		IxS = new cdouble[n*m];
  cdouble *Sm; 		Sm = new cdouble[n*m];
  cdouble *S; 		S = new cdouble[n*m];
  cdouble *eigVal; 	eigVal = new cdouble[n];
  cdouble *vecf; 	vecf = new cdouble[n];

  cdouble *M0; 		M0 = new cdouble[n];
  cdouble *data; 	data = new cdouble[n*m*2];

////////////////////////////////////////////////////////////////////////////////////////////////
//// NMR parameters that need to be passed

  int end = P->end ;
  cdouble deltaA , deltaB ;

  // chem shifts in rads / sec ; sign flip for some reason

  deltaA = -1. * P->deltaA * P->w0 * im * 2. * M_PI ;                  	// delta in rads/sec
  deltaB = -1. * P->deltaB * P->w0 * im * 2. * M_PI ;                  	// delta in rads/sec

//////////////////////////////////////////////////
// Chemical shift matx
  cdouble omega[2*2*2] = {
        { deltaA }  , { 0. , 0. } ,
        { 0. , 0. } , { deltaB }  
  };

// Relaxation matx
  cdouble relax[2*2*2] = {
        { P->R2A } , { 0. , 0. } , 
        { 0. , 0. } , { P->R2B } 
  };

// Population Vector; 

  M0[0] = P->MA ; 
  M0[1] = P->MB ; 

// combine chem shift, relax and exch into one matx

  zmat_add( order, omega, relax, data );

//////////////////////////////////////////////////

  cdouble one[2*2] = {
        { 1. , 0. } , { 1. , 0. } , 
  };

//////////////////////////////////////////////////

  zmat_cpy ( order , data , A ) ;
  zmat_cpy ( order , data , B ) ;
  zmat_eig ( order , A , Sm , eigVal ) ;
  zmat_inv ( order , Sm , S ) ;
  zmat_mlt ( order , S , B  , Sm , D ) ;

// Calc FID
    cdouble sum = {0,0} ;
  for ( int k = 0 ; k < P->end ; k++ ) {

    t = -1. * k * P->dw ;
    zmat_exp ( order , t , D , E ) ;
    zmat_mlt ( order , Sm , E , S , F ) ;
    zmat_rvm ( order , one , F , IxS ) ;
    zmat_rvv ( order , IxS , M0  , vecf ) ;

    sum = {0,0} ;
    for ( int j = 0 ; j < order ; j++ ) {
      sum = vecf[j]  + sum ;
    }
      FID[k] =  sum ;
  }

  delete [] A;
  delete [] B;
  delete [] vecf;

  }

///////////////////////////////////////
///////////////////////////////////////
///////////////////////////////////////
